build.sh 20 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747
  1. #!/usr/bin/env bash
  2. # Copyright 2018 Google
  3. #
  4. # Licensed under the Apache License, Version 2.0 (the "License");
  5. # you may not use this file except in compliance with the License.
  6. # You may obtain a copy of the License at
  7. #
  8. # http://www.apache.org/licenses/LICENSE-2.0
  9. #
  10. # Unless required by applicable law or agreed to in writing, software
  11. # distributed under the License is distributed on an "AS IS" BASIS,
  12. # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  13. # See the License for the specific language governing permissions and
  14. # limitations under the License.
  15. # USAGE: build.sh product [platform] [method]
  16. #
  17. # Builds the given product for the given platform using the given build method
  18. function pod_gen() {
  19. # Call pod gen with a podspec and additional optional arguments.
  20. bundle exec pod gen --local-sources=./ --sources=https://github.com/firebase/SpecsDev.git,https://github.com/firebase/SpecsStaging.git,https://cdn.cocoapods.org/ "$@"
  21. }
  22. set -euo pipefail
  23. if [[ $# -lt 1 ]]; then
  24. cat 1>&2 <<EOF
  25. USAGE: $0 product [platform] [method]
  26. product can be one of:
  27. Firebase
  28. Firestore
  29. CombineSwift
  30. InAppMessaging
  31. Messaging
  32. MessagingSample
  33. SwiftUISample
  34. MLModelDownloaderSample
  35. RemoteConfig
  36. RemoteConfigSample
  37. Sessions
  38. Storage
  39. SymbolCollision
  40. GoogleDataTransport
  41. Performance
  42. ClientApp
  43. platform can be one of:
  44. iOS (default)
  45. iOS-device
  46. macOS
  47. tvOS
  48. watchOS
  49. catalyst
  50. visionOS
  51. method can be one of:
  52. xcodebuild (default)
  53. cmake
  54. unit
  55. integration
  56. spm
  57. Optionally, reads the environment variable SANITIZERS. If set, it is expected to
  58. be a string containing a space-separated list with some of the following
  59. elements:
  60. asan
  61. tsan
  62. ubsan
  63. EOF
  64. exit 1
  65. fi
  66. product="$1"
  67. platform="iOS"
  68. if [[ $# -gt 1 ]]; then
  69. platform="$2"
  70. fi
  71. method="xcodebuild"
  72. if [[ $# -gt 2 ]]; then
  73. method="$3"
  74. fi
  75. echo "Building $product for $platform using $method"
  76. if [[ -n "${SANITIZERS:-}" ]]; then
  77. echo "Using sanitizers: $SANITIZERS"
  78. fi
  79. scripts_dir=$(dirname "${BASH_SOURCE[0]}")
  80. firestore_emulator="${scripts_dir}/run_firestore_emulator.sh"
  81. database_emulator="${scripts_dir}/run_database_emulator.sh"
  82. system=$(uname -s)
  83. case "$system" in
  84. Darwin)
  85. xcode_version=$(xcodebuild -version | grep Xcode)
  86. xcode_version="${xcode_version/Xcode /}"
  87. xcode_major="${xcode_version/.*/}"
  88. ;;
  89. *)
  90. xcode_major="0"
  91. ;;
  92. esac
  93. # Source function to check if CI secrets are available.
  94. source scripts/check_secrets.sh
  95. # Runs xcodebuild with the given flags, piping output to xcbeautify
  96. # If xcodebuild fails with known error codes, retries once.
  97. function RunXcodebuild() {
  98. echo xcodebuild "$@"
  99. local xcodebuild_args=("$@")
  100. local buildaction="${xcodebuild_args[$# - 1]}" # buildaction is the last arg
  101. local log_filename="xcodebuild-${buildaction}.log"
  102. local xcbeautify_cmd=(xcbeautify --renderer github-actions --disable-logging)
  103. local result=0
  104. NSUnbufferedIO=YES xcodebuild "$@" 2>&1 | tee "$log_filename" | \
  105. "${xcbeautify_cmd[@]}" && CheckUnexpectedFailures "$log_filename" \
  106. || result=$?
  107. if [[ $result == 65 ]]; then
  108. ExportLogs "$@"
  109. echo "xcodebuild exited with 65, retrying" 1>&2
  110. sleep 5
  111. result=0
  112. NSUnbufferedIO=YES xcodebuild "$@" 2>&1 | tee "$log_filename" | \
  113. "${xcbeautify_cmd[@]}" && CheckUnexpectedFailures "$log_filename" \
  114. || result=$?
  115. fi
  116. if [[ $result != 0 ]]; then
  117. echo "xcodebuild exited with $result" 1>&2
  118. ExportLogs "$@"
  119. return $result
  120. fi
  121. }
  122. # Exports any logs output captured in the xcresult
  123. function ExportLogs() {
  124. python "${scripts_dir}/xcresult_logs.py" "$@"
  125. }
  126. function CheckUnexpectedFailures() {
  127. local log_file=$1
  128. if grep -Eq "[1-9]\d* failures \([1-9]\d* unexpected\)" "$log_file"; then
  129. echo "xcodebuild failed with unexpected failures." 1>&2
  130. return 65
  131. fi
  132. }
  133. if [[ "$xcode_major" -lt 16 && "$method" != "cmake" ]]; then
  134. echo "Unsupported Xcode major version being used: $xcode_major"
  135. exit 1
  136. else
  137. ios_flags=(
  138. -sdk 'iphonesimulator'
  139. -destination 'platform=iOS Simulator,name=iPhone 16'
  140. )
  141. watchos_flags=(
  142. -sdk 'watchsimulator'
  143. -destination 'platform=watchOS Simulator,name=Apple Watch Series 10 (42mm)'
  144. )
  145. fi
  146. ios_device_flags=(
  147. -sdk 'iphoneos'
  148. -destination 'generic/platform=iOS'
  149. )
  150. ipad_flags=(
  151. -sdk 'iphonesimulator'
  152. -destination 'platform=iOS Simulator,name=iPad Pro (9.7-inch)'
  153. )
  154. macos_flags=(
  155. -sdk 'macosx'
  156. -destination 'platform=OS X,arch=x86_64'
  157. )
  158. tvos_flags=(
  159. -sdk "appletvsimulator"
  160. -destination 'platform=tvOS Simulator,name=Apple TV'
  161. )
  162. visionos_flags=(
  163. # As of Aug 15, 2025, the default OS "latest" was failing as it matched both
  164. # the visionOS 26 beta and visionOS 2.5 (from Xcode 16.4) simulators;
  165. # explicitly specifying OS=2.5 in destination as a workaround.
  166. -sdk 'xrsimulator'
  167. -destination 'platform=visionOS Simulator,OS=2.5,name=Apple Vision Pro'
  168. )
  169. catalyst_flags=(
  170. ARCHS=x86_64 VALID_ARCHS=x86_64 SUPPORTS_MACCATALYST=YES -sdk macosx
  171. -destination platform="macOS,variant=Mac Catalyst,arch=x86_64" TARGETED_DEVICE_FAMILY=2
  172. CODE_SIGN_IDENTITY=- CODE_SIGNING_REQUIRED=NO CODE_SIGNING_ALLOWED=NO
  173. )
  174. # Compute standard flags for all platforms
  175. case "$platform" in
  176. iOS)
  177. xcb_flags=("${ios_flags[@]}")
  178. gen_platform=ios
  179. ;;
  180. iOS-device)
  181. xcb_flags=("${ios_device_flags[@]}")
  182. gen_platform=ios
  183. ;;
  184. iPad)
  185. xcb_flags=("${ipad_flags[@]}")
  186. ;;
  187. macOS)
  188. xcb_flags=("${macos_flags[@]}")
  189. gen_platform=macos
  190. ;;
  191. tvOS)
  192. xcb_flags=("${tvos_flags[@]}")
  193. gen_platform=tvos
  194. ;;
  195. watchOS)
  196. xcb_flags=("${watchos_flags[@]}")
  197. ;;
  198. visionOS)
  199. xcb_flags=("${visionos_flags[@]}")
  200. ;;
  201. catalyst)
  202. xcb_flags=("${catalyst_flags[@]}")
  203. ;;
  204. all)
  205. xcb_flags=()
  206. ;;
  207. Linux)
  208. xcb_flags=()
  209. ;;
  210. *)
  211. echo "Unknown platform '$platform'" 1>&2
  212. exit 1
  213. ;;
  214. esac
  215. xcb_flags+=(
  216. ONLY_ACTIVE_ARCH=YES
  217. CODE_SIGNING_REQUIRED=NO
  218. CODE_SIGNING_ALLOWED=YES
  219. COMPILER_INDEX_STORE_ENABLE=NO
  220. )
  221. source scripts/buildcache.sh
  222. xcb_flags=("${xcb_flags[@]}" "${buildcache_xcb_flags[@]}")
  223. # TODO(varconst): Add --warn-unused-vars and --warn-uninitialized.
  224. # Right now, it makes the log overflow on Travis because many of our
  225. # dependencies don't build cleanly this way.
  226. cmake_options=(
  227. -Wdeprecated
  228. -DCMAKE_BUILD_TYPE=Debug
  229. )
  230. if [[ -n "${SANITIZERS:-}" ]]; then
  231. for sanitizer in $SANITIZERS; do
  232. case "$sanitizer" in
  233. asan)
  234. xcb_flags+=(
  235. -enableAddressSanitizer YES
  236. )
  237. cmake_options+=(
  238. -DWITH_ASAN=ON
  239. )
  240. ;;
  241. tsan)
  242. xcb_flags+=(
  243. -enableThreadSanitizer YES
  244. )
  245. cmake_options+=(
  246. -DWITH_TSAN=ON
  247. )
  248. ;;
  249. ubsan)
  250. xcb_flags+=(
  251. -enableUndefinedBehaviorSanitizer YES
  252. )
  253. cmake_options+=(
  254. -DWITH_UBSAN=ON
  255. )
  256. ;;
  257. *)
  258. echo "Unknown sanitizer '$sanitizer'" 1>&2
  259. exit 1
  260. ;;
  261. esac
  262. done
  263. fi
  264. case "$product-$platform-$method" in
  265. FirebasePod-iOS-*)
  266. RunXcodebuild \
  267. -workspace 'CoreOnly/Tests/FirebasePodTest/FirebasePodTest.xcworkspace' \
  268. -scheme "FirebasePodTest" \
  269. "${xcb_flags[@]}" \
  270. build
  271. ;;
  272. Auth-*-*)
  273. if check_secrets; then
  274. RunXcodebuild \
  275. -project 'FirebaseAuth/Tests/SampleSwift/AuthenticationExample.xcodeproj' \
  276. -scheme "$method" \
  277. "${xcb_flags[@]}" \
  278. test
  279. fi
  280. ;;
  281. CombineSwift-*-xcodebuild)
  282. pod_gen FirebaseCombineSwift.podspec --platforms=ios
  283. RunXcodebuild \
  284. -workspace 'gen/FirebaseCombineSwift/FirebaseCombineSwift.xcworkspace' \
  285. -scheme "FirebaseCombineSwift-Unit-unit" \
  286. "${xcb_flags[@]}" \
  287. build
  288. ;;
  289. # TODO(#14760): s/build/test after addressing UI test flakes on CI.
  290. InAppMessaging-*-xcodebuild)
  291. RunXcodebuild \
  292. -workspace 'FirebaseInAppMessaging/Tests/Integration/DefaultUITestApp/InAppMessagingDisplay-Sample.xcworkspace' \
  293. -scheme 'FiamDisplaySwiftExample' \
  294. "${xcb_flags[@]}" \
  295. build
  296. ;;
  297. Firestore-*-xcodebuild)
  298. "${firestore_emulator}" start
  299. trap '"${firestore_emulator}" stop' ERR EXIT
  300. RunXcodebuild \
  301. -workspace 'Firestore/Example/Firestore.xcworkspace' \
  302. -scheme "Firestore_IntegrationTests_$platform" \
  303. -enableCodeCoverage YES \
  304. "${xcb_flags[@]}" \
  305. test
  306. ;;
  307. Firestore-macOS-cmake | Firestore-Linux-cmake)
  308. "${firestore_emulator}" start
  309. trap '"${firestore_emulator}" stop' ERR EXIT
  310. (
  311. test -d build || mkdir build
  312. cd build
  313. echo "Preparing cmake build ..."
  314. cmake -G Ninja "${cmake_options[@]}" ..
  315. echo "Building cmake build ..."
  316. ninja -k 10 all
  317. ctest --verbose
  318. )
  319. ;;
  320. SymbolCollision-*-*)
  321. RunXcodebuild \
  322. -workspace 'SymbolCollisionTest/SymbolCollisionTest.xcworkspace' \
  323. -scheme "SymbolCollisionTest" \
  324. "${xcb_flags[@]}" \
  325. build
  326. ;;
  327. # TODO(#12205) Restore this test to "test" instead of "build"
  328. Messaging-*-xcodebuild)
  329. pod_gen FirebaseMessaging.podspec --platforms=ios
  330. # Add GoogleService-Info.plist to generated Test Wrapper App.
  331. ruby ./scripts/update_xcode_target.rb gen/FirebaseMessaging/Pods/Pods.xcodeproj \
  332. AppHost-FirebaseMessaging-Unit-Tests \
  333. ../../../FirebaseMessaging/Tests/IntegrationTests/Resources/GoogleService-Info.plist
  334. if check_secrets; then
  335. # Integration tests are only run on iOS to minimize flake failures.
  336. RunXcodebuild \
  337. -workspace 'gen/FirebaseMessaging/FirebaseMessaging.xcworkspace' \
  338. -scheme "FirebaseMessaging-Unit-integration" \
  339. "${ios_flags[@]}" \
  340. "${xcb_flags[@]}" \
  341. build
  342. fi
  343. ;;
  344. MessagingSample-*-*)
  345. if check_secrets; then
  346. RunXcodebuild \
  347. -workspace 'FirebaseMessaging/Apps/Sample/Sample.xcworkspace' \
  348. -scheme "Sample" \
  349. "${xcb_flags[@]}" \
  350. build
  351. fi
  352. ;;
  353. SwiftUISample-*-*)
  354. if check_secrets; then
  355. RunXcodebuild \
  356. -workspace 'FirebaseMessaging/Apps/SwiftUISample/SwiftUISample.xcworkspace' \
  357. -scheme "SwiftUISample" \
  358. "${xcb_flags[@]}" \
  359. build
  360. fi
  361. ;;
  362. # TODO: This is actually building for iOS instead of watchOS. Update to use
  363. # watchOS xcb_flags along with the watchOS sdk option. Also nanopb and promises
  364. # podspecs need minimum version updates.
  365. MessagingSampleStandaloneWatchApp-*-*)
  366. if check_secrets; then
  367. RunXcodebuild \
  368. -workspace 'FirebaseMessaging/Apps/SampleStandaloneWatchApp/SampleStandaloneWatchApp.xcworkspace' \
  369. -scheme "SampleStandaloneWatchApp Watch App" \
  370. -destination 'platform=watchOS Simulator,name=Apple Watch Series 10 (42mm)' \
  371. build
  372. fi
  373. ;;
  374. MLModelDownloaderSample-*-*)
  375. if check_secrets; then
  376. RunXcodebuild \
  377. -workspace 'FirebaseMLModelDownloader/Apps/Sample/MLDownloaderTestApp.xcworkspace' \
  378. -scheme "MLDownloaderTestApp" \
  379. "${xcb_flags[@]}" \
  380. build
  381. fi
  382. ;;
  383. WatchOSSample-*-*)
  384. RunXcodebuild \
  385. -workspace 'Example/watchOSSample/SampleWatchApp.xcworkspace' \
  386. -scheme "SampleWatchAppWatchKitApp" \
  387. "${xcb_flags[@]}" \
  388. build
  389. ;;
  390. Database-*-integration)
  391. "${database_emulator}" start
  392. trap '"${database_emulator}" stop' ERR EXIT
  393. pod_gen FirebaseDatabase.podspec --platforms="${gen_platform}"
  394. RunXcodebuild \
  395. -workspace 'gen/FirebaseDatabase/FirebaseDatabase.xcworkspace' \
  396. -scheme "FirebaseDatabase-Unit-integration" \
  397. "${xcb_flags[@]}" \
  398. build \
  399. test
  400. ;;
  401. RemoteConfig-*-fakeconsole)
  402. pod_gen FirebaseRemoteConfig.podspec --platforms="${gen_platform}"
  403. RunXcodebuild \
  404. -workspace 'gen/FirebaseRemoteConfig/FirebaseRemoteConfig.xcworkspace' \
  405. -scheme "FirebaseRemoteConfig-Unit-fake-console-tests" \
  406. "${xcb_flags[@]}" \
  407. build \
  408. test
  409. ;;
  410. RemoteConfig-*-integration)
  411. pod_gen FirebaseRemoteConfig.podspec --platforms="${gen_platform}"
  412. # Add GoogleService-Info.plist to generated Test Wrapper App.
  413. ruby ./scripts/update_xcode_target.rb gen/FirebaseRemoteConfig/Pods/Pods.xcodeproj \
  414. AppHost-FirebaseRemoteConfig-Unit-Tests \
  415. ../../../FirebaseRemoteConfig/Tests/Swift/SwiftAPI/GoogleService-Info.plist
  416. # Add AccessToken to generated Test Wrapper App.
  417. ruby ./scripts/update_xcode_target.rb gen/FirebaseRemoteConfig/Pods/Pods.xcodeproj \
  418. AppHost-FirebaseRemoteConfig-Unit-Tests \
  419. ../../../FirebaseRemoteConfig/Tests/Swift/AccessToken.json
  420. # Integration tests are only run on iOS to minimize flake failures.
  421. RunXcodebuild \
  422. -workspace 'gen/FirebaseRemoteConfig/FirebaseRemoteConfig.xcworkspace' \
  423. -scheme "FirebaseRemoteConfig-Unit-swift-api-tests" \
  424. "${xcb_flags[@]}" \
  425. build \
  426. test
  427. ;;
  428. RemoteConfigSample-*-*)
  429. RunXcodebuild \
  430. -workspace 'FirebaseRemoteConfig/Tests/Sample/RemoteConfigSampleApp.xcworkspace' \
  431. -scheme "RemoteConfigSampleApp" \
  432. "${xcb_flags[@]}" \
  433. build
  434. ;;
  435. FirebaseAIIntegration-*-*)
  436. # Build
  437. RunXcodebuild \
  438. -project 'FirebaseAI/Tests/TestApp/FirebaseAITestApp.xcodeproj' \
  439. -scheme "FirebaseAITestApp-SPM" \
  440. "${xcb_flags[@]}" \
  441. build
  442. # Run tests
  443. RunXcodebuild \
  444. -project 'FirebaseAI/Tests/TestApp/FirebaseAITestApp.xcodeproj' \
  445. -scheme "FirebaseAITestApp-SPM" \
  446. "${xcb_flags[@]}" \
  447. -parallel-testing-enabled NO \
  448. -retry-tests-on-failure \
  449. -test-iterations 3 \
  450. test
  451. ;;
  452. Sessions-*-integration)
  453. # Perform "pod install" to install the relevant dependencies
  454. # ./FirebaseSessions/generate_testapp.sh
  455. pod_gen FirebaseSessions.podspec --platforms=ios --clean
  456. cd FirebaseSessions/Tests/TestApp; pod install; cd -
  457. # Run E2E Integration Tests for Prod.
  458. RunXcodebuild \
  459. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  460. -scheme "AppQualityDevApp_iOS" \
  461. "${ios_flags[@]}" \
  462. "${xcb_flags[@]}" \
  463. build \
  464. test
  465. # Run E2E Integration Tests for Staging.
  466. RunXcodebuild \
  467. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  468. -scheme "AppQualityDevApp_iOS" \
  469. FirebaseSessionsRunEnvironment=STAGING \
  470. "${ios_flags[@]}" \
  471. "${xcb_flags[@]}" \
  472. build \
  473. test
  474. # Run E2E Integration Tests for Autopush.
  475. RunXcodebuild \
  476. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  477. -scheme "AppQualityDevApp_iOS" \
  478. FirebaseSessionsRunEnvironment=AUTOPUSH \
  479. "${ios_flags[@]}" \
  480. "${xcb_flags[@]}" \
  481. build \
  482. test
  483. ;;
  484. StorageSwift-*-xcodebuild)
  485. pod_gen FirebaseStorage.podspec --platforms=ios
  486. # Add GoogleService-Info.plist to generated Test Wrapper App.
  487. ruby ./scripts/update_xcode_target.rb gen/FirebaseStorage/Pods/Pods.xcodeproj \
  488. AppHost-FirebaseStorage-Unit-Tests \
  489. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  490. if check_secrets; then
  491. # Integration tests are only run on iOS to minimize flake failures.
  492. RunXcodebuild \
  493. -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
  494. -scheme "FirebaseStorage-Unit-integration" \
  495. "${ios_flags[@]}" \
  496. "${xcb_flags[@]}" \
  497. test
  498. fi
  499. ;;
  500. StorageObjC-*-xcodebuild)
  501. pod_gen FirebaseStorage.podspec --platforms=ios
  502. # Add GoogleService-Info.plist to generated Test Wrapper App.
  503. ruby ./scripts/update_xcode_target.rb gen/FirebaseStorage/Pods/Pods.xcodeproj \
  504. AppHost-FirebaseStorage-Unit-Tests \
  505. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  506. if check_secrets; then
  507. # Integration tests are only run on iOS to minimize flake failures.
  508. RunXcodebuild \
  509. -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
  510. -scheme "FirebaseStorage-Unit-ObjCIntegration" \
  511. "${ios_flags[@]}" \
  512. "${xcb_flags[@]}" \
  513. test
  514. fi
  515. ;;
  516. StorageCombine-*-xcodebuild)
  517. pod_gen FirebaseCombineSwift.podspec --platforms=ios
  518. # Add GoogleService-Info.plist to generated Test Wrapper App.
  519. ruby ./scripts/update_xcode_target.rb gen/FirebaseCombineSwift/Pods/Pods.xcodeproj \
  520. AppHost-FirebaseCombineSwift-Unit-Tests \
  521. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  522. if check_secrets; then
  523. # Integration tests are only run on iOS to minimize flake failures.
  524. RunXcodebuild \
  525. -workspace 'gen/FirebaseCombineSwift/FirebaseCombineSwift.xcworkspace' \
  526. -scheme "FirebaseCombineSwift-Unit-integration" \
  527. "${ios_flags[@]}" \
  528. "${xcb_flags[@]}" \
  529. test
  530. fi
  531. ;;
  532. GoogleDataTransport-watchOS-xcodebuild)
  533. RunXcodebuild \
  534. -workspace 'GoogleDataTransport/GDTWatchOSTestApp/GDTWatchOSTestApp.xcworkspace' \
  535. -scheme "GDTWatchOSTestAppWatchKitApp" \
  536. "${xcb_flags[@]}" \
  537. build
  538. RunXcodebuild \
  539. -workspace 'GoogleDataTransport/GDTCCTWatchOSTestApp/GDTCCTWatchOSTestApp.xcworkspace' \
  540. -scheme "GDTCCTWatchOSIndependentTestAppWatchKitApp" \
  541. "${xcb_flags[@]}" \
  542. build
  543. RunXcodebuild \
  544. -workspace 'GoogleDataTransport/GDTCCTWatchOSTestApp/GDTCCTWatchOSTestApp.xcworkspace' \
  545. -scheme "GDTCCTWatchOSCompanionTestApp" \
  546. "${xcb_flags[@]}" \
  547. build
  548. ;;
  549. Performance-*-unit)
  550. # Run unit tests on prod environment with unswizzle capabilities.
  551. export FPR_UNSWIZZLE_AVAILABLE="1"
  552. export FPR_AUTOPUSH_ENV="0"
  553. pod_gen FirebasePerformance.podspec --platforms="${gen_platform}"
  554. RunXcodebuild \
  555. -workspace 'gen/FirebasePerformance/FirebasePerformance.xcworkspace' \
  556. -scheme "FirebasePerformance-Unit-unit" \
  557. "${xcb_flags[@]}" \
  558. build \
  559. test
  560. ;;
  561. Performance-*-proddev)
  562. # Build the prod dev test app.
  563. export FPR_UNSWIZZLE_AVAILABLE="0"
  564. export FPR_AUTOPUSH_ENV="0"
  565. pod_gen FirebasePerformance.podspec --platforms="${gen_platform}"
  566. RunXcodebuild \
  567. -workspace 'gen/FirebasePerformance/FirebasePerformance.xcworkspace' \
  568. -scheme "FirebasePerformance-TestApp" \
  569. "${xcb_flags[@]}" \
  570. build
  571. ;;
  572. Performance-*-integration)
  573. # Generate the workspace for the SDK to generate Protobuf files.
  574. export FPR_UNSWIZZLE_AVAILABLE="0"
  575. pod_gen FirebasePerformance.podspec --platforms=ios --clean
  576. # Perform "pod install" to install the relevant dependencies
  577. cd FirebasePerformance/Tests/FIRPerfE2E; pod install; cd -
  578. # Run E2E Integration Tests for Autopush.
  579. RunXcodebuild \
  580. -workspace 'FirebasePerformance/Tests/FIRPerfE2E/FIRPerfE2E.xcworkspace' \
  581. -scheme "FIRPerfE2EAutopush" \
  582. FPR_AUTOPUSH_ENV=1 \
  583. "${ios_flags[@]}" \
  584. "${xcb_flags[@]}" \
  585. build \
  586. test
  587. # Run E2E Integration Tests for Prod.
  588. RunXcodebuild \
  589. -workspace 'FirebasePerformance/Tests/FIRPerfE2E/FIRPerfE2E.xcworkspace' \
  590. -scheme "FIRPerfE2EProd" \
  591. "${ios_flags[@]}" \
  592. "${xcb_flags[@]}" \
  593. build \
  594. test
  595. ;;
  596. FirebaseDataConnect-*-spm)
  597. RunXcodebuild \
  598. -scheme $product \
  599. "${xcb_flags[@]}" \
  600. IPHONEOS_DEPLOYMENT_TARGET=15.0 \
  601. TVOS_DEPLOYMENT_TARGET=15.0 \
  602. test
  603. ;;
  604. # Note that the combine tests require setting the minimum iOS and tvOS version to 13.0
  605. *-*-spm)
  606. RunXcodebuild \
  607. -scheme $product \
  608. "${xcb_flags[@]}" \
  609. IPHONEOS_DEPLOYMENT_TARGET=13.0 \
  610. TVOS_DEPLOYMENT_TARGET=13.0 \
  611. test
  612. ;;
  613. *-*-spmbuildonly)
  614. RunXcodebuild \
  615. -scheme $product \
  616. "${xcb_flags[@]}" \
  617. build
  618. ;;
  619. ClientApp-iOS-xcodebuild | ClientApp-iOS13-iOS-xcodebuild)
  620. RunXcodebuild \
  621. -project 'IntegrationTesting/ClientApp/ClientApp.xcodeproj' \
  622. -scheme $product \
  623. "${xcb_flags[@]}" \
  624. build
  625. ;;
  626. ClientApp-CocoaPods*-iOS-xcodebuild)
  627. RunXcodebuild \
  628. -workspace 'IntegrationTesting/ClientApp/ClientApp.xcworkspace' \
  629. -scheme $product \
  630. "${xcb_flags[@]}" \
  631. build
  632. ;;
  633. *)
  634. echo "Don't know how to build this product-platform-method combination" 1>&2
  635. echo " product=$product" 1>&2
  636. echo " platform=$platform" 1>&2
  637. echo " method=$method" 1>&2
  638. exit 1
  639. ;;
  640. esac